/*
 (C) 3.1998  Petr Lastovicka
*/
#include <stdlib.h>
#include <conio.h>
#include <time.h>

#ifdef WIN32
#include "winConsole.h"
#else
#include <mem.h>
#include <dos.h>
#endif

#define L left();
#define R right();
#define U up();
#define D down();

int xm=3,ym=3, hraPC=0, pauza;
int p[10][13], p1[10][13]; //vka x ka
int i,j, r,s, x,y, x1,y1, tah,hi, konec;
unsigned char c;
char *text=
" ESC = Konec    F2 = Nov hra    F4 = Znovu stejn zadn    F8 = Jin rozmry\r\n"
" 0-9 = Hra potae   0 = rychle   9 = pomalu   ENTER = krokovat";


int rnd(int a){ return (int)((double)rand()*a/(RAND_MAX+1)); }

// souadnice na obrazovce
int fx(int a){ return a*6+(13-xm)*3; }
int fy(int a){ return a*2+10-ym; }

// vybere nhodn jedno polko
int fxy(int *a,int *b)
{
  do{
    *a=rnd(xm+1); *b=rnd(ym+1);
  }while(*a==xm && *b==ym); // prav doln roh je przdn
  return p[*b][*a];
}

void ret(char* r,int d)
{
 while(d--) cputs(r);
}

//vytiskne zadn
void tisk()
{
 int i= fx(0)-2;

 clrscr();
 gotoxy(i,fy(0)-1); cputs(""); ret("",xm); cputs("Ŀ");
 gotoxy(i,fy(0)); cputs(""); ret("     ",xm); cputs("     ");
 for(y=1; y<=ym; y++){
   gotoxy(i,fy(y)-1); cputs(""); ret("",xm); cputs("Ĵ");
   gotoxy(i,fy(y)); cputs(""); ret("     ",xm); cputs("     ");
 }
 gotoxy(i,fy(y)-1); cputs(""); ret("",xm); cputs("");
 for(y=0; y<=ym; y++)
  for(x=0; x<=xm; x++){
   gotoxy(fx(x),fy(y));
   if(p[y][x]<10) cputs(" ");
   cprintf("%d",p[y][x]);
  }
 gotoxy(fx(x=xm),fy(y=ym)); cputs("   ");
 gotoxy(1,24); cputs(text);
 if(hi){ gotoxy(20,22); cprintf("Nejlep: %d",hi); }
 gotoxy(2,22); cputs("Poet tah: 0");
 tah=0;
 konec=0;
}

// vygeneruje nov zadn a vytiskne
void nova()
{
int i,j;

 hi=0;
 i=0;
 for(y=i; y<=ym; y++){
  for(x=0;x<=xm;x++)
    p[y][x]=++i;
 }
 //udlej sudou permutaci
 for(i=1; i<=80; i++){
   j=fxy(&x,&y);
   do{ fxy(&x1,&y1); }while(x1==x && y1==y);
   p[y][x]=p[y1][x1];
   p[y1][x1]=j;
 }
 //uchovej zadn
 memcpy(p1,p,sizeof p);
 tisk();
}

// Posune slo z [x,y] na [x1,y1]. Pot tahy
void posun()
{
static unsigned tabspeed[10]={ 0,20,50,100,200,400,700,1000,2000,3000 };
unsigned char c;

 if(hraPC){
  if(pauza>=0){
    delay(tabspeed[pauza]);
#ifdef WIN32
    if(!_kbhit()) goto neni_znak;
#else
    asm{
      mov ah,0x11
      int 0x16
      jz neni_znak
    }
#endif
  }
  if((c=getch())==0) c=getch();
  else{
   if(c>='0' && c<='9') pauza= c-'0';
   else if(c==13) pauza=-1;
   else if(c==27) pauza=0;
  }
  neni_znak: ;
 }

 gotoxy(fx(x1),fy(y1));
 if( ( p[y1][x1]=p[y][x] )<10 ) putch(' ');
 cprintf("%d",p[y][x]);
 gotoxy(fx(x),fy(y)); cputs("   ");
 tah++;
 gotoxy(14,22); cprintf("%d",tah);
 p[y][x]=0;
}

void left(){  x1=x++; y1=y; posun();}
void right(){ x1=x--; y1=y; posun();}
void up(){    y1=y++; x1=x; posun();}
void down(){  y1=y--; x1=x; posun();}

// pesune przdn polko na pozici [a,b]
void na(int a,int b)
{
 while(b>y) U
 while(a>x) L
 while(a<x) R
 while(b<y) D
}

//pesune slo z polka [xs,ys] na [xk,yk]
void mov(int xs,int ys,int xk,int yk)
{
 int d,dx,dy;

 if(xs==xk && ys==yk) return;
 if(yk==r && xk<s+2 && xs<xk && ys!=r){ mov(xs,ys,xk,yk+1); xs=x1; ys=y1;}
 if(( d=( abs(dx=xk-xs)-abs(dy=yk-ys) ) )!=0)
  if(d>0)
    if(dx>0){
     if(x>=xs || y!=ys){
       if(x<=xs) na(xs+1,y);
       na(xs+1,ys); R d--;
     }else na(xs-1,ys);
     for(;d>0;d--){
       if(y<ym){ U L L D } else { D L L U }
       R
     }
    }else{
     if(x<=xs || y!=ys){
       if(x>=xs) na(xs-1,y);
       na(xs-1,ys); L d--;
     }else na(xs+1,ys);
     for(;d>0;d--){
       if(y<ym){ U R R D } else { D R R U }
       L
     }
    }
  else//(d<0)
    if(dy>0){
     if(y>=ys || x!=xs){
       if(y<=ys) na(x,ys+1);
       na(xs,ys+1); D d++;
     }else na(xs,ys-1);
     for(;d<0;d++){
       if(x<xm){ L U U R } else { R U U L }
       D
     }
    }else{
     if((y<=ys || x!=xs) && (x>=s || ys>r+1)){
       if(y>=ys) na(x,ys-1);
       na(xs,ys-1); U  d++;
     }else na(xs,ys+1);
     for(;d<0;d++){
       if(x<xm){ L D D R } else { R D D L }
       U
     }
    }
 //(d=0)
 else if(dx>0 && (x>xs || x==xs && dy*(y-ys)<0)) mov(xs,ys,xs+1,ys);
 else if(dx<0 && (x<xs || x==xs && dy*(y-ys)<0)) mov(xs,ys,xs-1,ys);
 else if(dy>0) mov(xs,ys,xs,ys+1);
 else mov(xs,ys,xs,ys-1);

 for(d=abs(xk-x1)+abs(yk-y1);d>0;d--)
  if(x==x1)
    if(y>y1) if(x>xk){ R D L } else { L D R }
        else if(x>xk){ R U L } else { L U R }
  else
    if(x>x1) if(y<yk){ U R D } else { D R U }
        else if(y<yk){ U L D } else { D L U }
}

// pesune slo k na polko [a,b]
void dej(int k,int a,int b)
{
int i,j;

 for(i=r; ;i++)
  for(j=0; j<=xm; j++)
    if(p[i][j]==k){ mov(j,i,a,b); return; }
}


// hlavn procedura celho algoritmu
void pocitac()
{
int r1=1,s1,y3,x3,y4,x4,K1,K2,cis=1;

 if(konec) nova();
 hraPC=1;
 gotoxy(1,24); ret(" ",86);

 for(r=0;r<ym-1; r1++,r++){
  for(s=0;s<xm-1;s++) dej(cis++,s,r);

//____Posledn 2 sla na dku r
  K1=cis++; K2=cis++;
  if(p[r][xm]==K1 && p[r][s]==K2)
    if(x==xm) na(x,r);
    else na(s,r);
  if(y==r){
    if(p[r1][s]==K1 && (p[r][xm]==K2 || p[r1][xm]==K2) ||
      p[r1][xm]==K2 && (p[r][s]==K1 || p[r1][s]==K1) ) U
    else if(p[r][s]==K2 && p[r1][xm]==K1) R
    else if(p[r][xm]==K1 && p[r1][s]==K2) L
    else if(p[r1][x]==K1) U
  }
  if(p[r][s]==K1 && p[r][xm]==K2) continue;
  if(p[r][s]==K1){
    if(p[r1][xm]==K2 && x<xm) na(xm,r+2);
    else if(p[r1][s]==K2) mov(s,r1,s,r+2);
    na(xm,r1); D R U
  }else if(p[r][xm]==K2){
    if(p[r1][s]==K1 && x==xm && y==r1) U
    else if(p[r1][xm]==K1) mov(xm,r1,xm,r+2);
    na(s,r); L U
  }else if(p[r][s]!=K2 && p[r][xm]!=K1) dej(K2,s,r);
  if(p[r][s]==K2){
    dej(K1,s,r1);
    if(y==r1 && x<s) U
    na(xm,r); R U
  }else{
    dej(K2,xm,r1); na(s,r); L U
  }
 }//endfor

//_____Posledn 2 dky
 for(s=0,s1=1; s<xm-1; s1++,s++){
  K1=cis++; K2=cis+xm;
  if(p[r][s]==K1 && p[ym][s]==K2) continue;
  for(i=r;;i++) for(j=s;j<=xm;j++)
    if(p[i][j]==K1){ y3=i, x3=j; goto N1;}
N1:
  for(i=r;;i++) for(j=s;j<=xm;j++)
    if(p[i][j]==K2){ y4=i, x4=j; goto N2;}
N2:

  if(x3==x4){ na(x3,y); if(y==y3) x3=x1; else x4=x1;}
  if(x==s && (p[ym][s]==K1 || p[r][s]==K2) && (p[ym][s1]==K1 || p[r][s1]==K2))
    if(y==r) { U y3=r;} else { D y4=ym;}

  if(x3>x4 && y4==ym)
   if(y3==ym)
    if(x3==x4+1 && x4>s) mov(x3-1,ym,--x4,--y4);
    else{
      if(x>x4 || x3==s1){ mov(x3,y3,x4+2,y3); x3=x4+2;}
      mov(x4,ym,x4,--y4);
    }
   else{
      if(x>x4 && x3>x4+2){ mov(x3,y3,x4+2,y3); x3=x1;}
      if(x3==s1)
        if(x==s){ L continue;}
        else mov(s1,y3,++x3,y3);
      if(x>=x3){ na(x4+1,y4); if(x3==x4+1) y3++;}
      if(y==ym) D
      na(x4,--y4); U
   }
  else if(x4>x3 && y3==r)
   if(y4==r)
    if(x4==x3+1 && x3>s) mov(x4-1,r,--x3,++y3);
    else{
      if(x>x3 || x4==s1){ mov(x4,y4,x3+2,y4); x4=x3+2;}
      mov(x3,r,x3,++y3);
    }
   else{
     if(x>x3 && x4>x3+2){ mov(x4,y4,x3+2,y4); x4=x1;}
     if(x4==s1)
       if(x==s){ L continue;}
       else mov(s1,y4,++x4,y4);
     if(x>=x4){ if(x4==x3+1) y4--; if(y==ym) D na(x3+1,y);}
     na(x3,++y3); D
   }

  if(y3!=y4)
   if(x3<x4){
     if(x<=x3)
       if(x3+1==x4) mov(x4-1,y3,--x3,y3);
       else if(y==y3) --x3;
     if(x+1==x4 && y==ym) D
     mov(x4,r,x3+1,++y4); x4=x1;
   }else{
     if(x<=x4)
       if(x4+1==x3) mov(x3-1,y4,--x4,y4);
       else if(y==r) na(x4--,y);
     if(x+1==x3 && y==r) U
     mov(x3,ym,x4+1,--y3); x3=x1;
   }

  if(y3==r){
    if(x==x4 && x3>x+1) L
    if(x<x4){ na(--x4,y4); L}
    mov(x3,y3,x4+1,y4);
    if(x<x4 || y!=y4){
     if(x4==s) na(s,y);
     else{
     na(x4-1,y4); L L}}
    else na(x4+2,y);
    while(x>s+2){ U R R R D L L }
    if(x>s){ U R R }
    D L
  }
  else{
    if(x==x3 && x4>x+1) L
    if(x<x3){ na(--x3,y3); L}
    mov(x4,y4,x3+1,y3);
    if(x<x3 || y!=y3){
     if(x3==s) na(s,y);
		 else{ if(x>=x3) na(x3-1,y);
     na(x3-1,y3); L L}}
    else na(x3+2,y);
    while(x>s+2){ D R R R U L L }
    if(x>s){ D R R }
    U L
  }
 }//endfor
 dej(cis,xm-1,ym-1); na(xm,ym);

 konec=1;
 hraPC=0;
}


main()
{
#ifdef WIN32
  initConsole();
#endif
 _setcursortype(_NOCURSOR);
 srand((unsigned)time(NULL));
 nova();
 for(;;){
   gotoxy(1,24); cputs(text);
   if((c=getch())==0) c=getch();
   x1=x, y1=y;
   if(!konec)
    switch(c){
     case 77: if(x>0) x--; break;
     case 75: if(x<xm) x++; break;
     case 72: if(y<ym) y++; break;
     case 80: if(y>0) y--; break;
    }
   if(x!=x1 || y!=y1){
     posun();
    // test konce hry
     if(x==xm && y==ym){
       i=0;
       for(y1=0; y1<=ym; y1++)
         for(x1=0; x1<=xm; x1++)
           if(++i != p[y1][x1] && (y1<y || x1<xm)) goto neni_konec;
       gotoxy(40,22); cputs("Gratuluji !");
       if(tah<hi || !hi){ hi=tah; cputs("!!"); }
       konec=1;
      neni_konec: ;
     }
   }
   if(c>='0' && c<='9'){
     pauza= c-'0';
     pocitac();
   }else
   switch(c){
    case 66: //F8
     clrscr();
     gotoxy(1,5); cprintf("  Zadej ku (max. 12) : "); cscanf("%d",&xm);
     if(--xm<1) xm=1;
     if(xm>12) xm=12;
     cprintf("\r\n\n  Zadej vku (max. 9) : "); cscanf("%d",&ym); getch();
     if(--ym<1) ym=1;
     if(ym>9) ym=9;
    //
    case 60: //F2
     nova();
    break;
    case 62: //F4
     memcpy(p,p1,sizeof(p));
     tisk();
    break;
    case 13: //ENTER
     pauza=-1;
     if(!konec) pocitac();
    break;
    case 27: //ESC
     return 0;
   }
 }
}
